<template lang="pug">
div(style="width: 100%")
  q-dialog(v-model="addingNewMessage")
    EditMessage(
      :cancel="() => (addingNewMessage = false)",
      :save="handleCreateNewMessage",
      :zoomSensors="zoomSensors"
    )
  q-card(transition="scale")
    q-card-section.q-pb-none
      .row.items-center
        .text-h6.q-mr-md Messages:
        q-btn(
          v-if="createNewMessage",
          round,
          dense,
          color="primary",
          icon="add",
          @click="addingNewMessage = true"
        )
    q-card-section
      q-list(bordered, separator)
        MessageItem(
          v-for="(message, index) in messages",
          :key="index",
          :message="message",
          :sectionStartTime="sectionStartTime",
          :sectionEndTime="sectionEndTime",
          :editMessage="!editMessage ? undefined : (editedMessage) => editMessage(editedMessage, index)",
          :sendMessage="!sendMessage ? undefined : () => sendMessage(index)",
          :zoomSensors="zoomSensors",
          :deleteMessage="!deleteMessage ? undefined : () => deleteMessage(index)"
        )
        q-item.text-center.items-center.q-pa-lg(
          v-if="!Object.entries(messages || {}).length"
        ) No Messages
</template>
<script>
import MessageItem from "./MessageItem.vue";
import EditMessage from "./EditMessage.vue";

export default {
  props: {
    messages: { required: true },
    sectionStartTime: { required: true },
    sectionEndTime: { required: true },
    editMessage: { required: false },
    sendMessage: { required: false },
    zoomSensors: { required: true },
    createNewMessage: { required: false },
    deleteMessage: { required: false },
  },
  data() {
    return {
      addingNewMessage: false,
    };
  },
  methods: {
    async handleCreateNewMessage(message) {
      await this.createNewMessage(message);
      this.addingNewMessage = false;
    },
  },
  components: {
    MessageItem,
    EditMessage,
  },
};
</script>
